// Send a fake keystroke event to an X window.
// by Adam Pierce - http://www.doctort.org/adam/
// This is public domain software. It is free to use by anyone for any purpose.

#include <X11/Xlib.h>
#include <X11/keysym.h>

// The key code to be sent.
// A full list of available codes can be found in /usr/include/X11/keysymdef.h
#define KEYCODE XK_Down
#define bool BOOL
Window registered_wid();

// Function to create a keyboard event
static XButtonEvent createKeyEvent(Display *display, Window *win,
                           Window *winRoot, bool press,
                           int keycode, int modifiers,int x,int y)
{
   XButtonEvent event;

   event.display     = display;
   event.window      = *win;
   event.root        = *winRoot;
   event.subwindow   = None;
   event.time        = CurrentTime;
   event.x           = x;
   event.y           = y-560;
   event.x_root      = x;
   event.y_root      = y;
   event.same_screen = True;
   //event.keycode     = XKeysymToKeycode(display, keycode);
   event.button      = keycode;
   event.state       = modifiers;

   event.type = (press)?ButtonPress:ButtonRelease;

   return event;
}

static int xfkSendButton(int btn,bool press,int ax,int ay)
{
// Obtain the X11 display.
   Display *display = XOpenDisplay(0);
   if(display == NULL)
      return -1;

// Get the root window for the current display.
   Window winRoot = XDefaultRootWindow(display);

// Find the window which has the current keyboard focus.
   Window winFocus;
   /*int    revert;
   XGetInputFocus(display, &winFocus, &revert);*/
   winFocus = registered_wid();
   //valid?

   long mask=(press)?ButtonPressMask:ButtonReleaseMask;
// Send a fake key press event to the window.
   XButtonEvent event = createKeyEvent(display, &winFocus, &winRoot, press, btn, 0,ax,ay);
   XSendEvent(event.display, event.window, FALSE, mask, (XEvent *)&event);

// Done.
   XCloseDisplay(display);
   return 0;
}
#define CLICKXY(btn,ax,ay) xfkSendButton(btn,1,ax,ay);xfkSendButton(btn,0,ax,ay)
#define xfkSendButtonv(btn,p,v) xfkSendButton(btn,p,valuator_mask_get(v, 0),valuator_mask_get(v, 1))

//sends a cursor-down event to the currently focussed window
//g++ -o XFakeKey XFakeKey.cpp -L/usr/X11R6/lib -lX11

int preq(char *cmd)
{	const char*rodv="/tmp/preq";
	static FILE*f;static struct stat st;
	f=fopen(rodv,"wb");
	static int pos;static int size;
	if(f==NULL){return 1;};
	pos=0;
	size= fwrite(cmd, strlen(cmd),1, f);
	size= fwrite("\n", 1,1, f);
	fclose(f);
	while(stat(rodv, &st) != -1){};
	f=fopen("/tmp/preqex","rb");
	if(f==NULL){return 0;};
	fclose(f);
	return 1
;
}

#define HAVE_XI2 1
#include "xin/buttonmap.c"
#include "xin/feedback.c"
#include "xin/hierarchy.c"
#include "xin/list.c"
#include "xin/property.c"
#include "xin/setcp.c"
#include "xin/setint.c"
#include "xin/setmode.c"
#include "xin/setptr.c"
#include "xin/state.c"
#include "xin/test.c"
#include "xin/test_xi2.c"
#include "xin/transform.c"
#include "xinput_fake.c"
int xinputwrap_create_master(){char* arr[]={"","--create-master","Keyb"};
return main_ish(3,arr);}
int xinputwrap_reattach( char* what){ char* arr[]={"","--reattach","MultiTouchEV",""};arr[3]=what;
return main_ish(4,arr);}
int xinput_helper(int switch_){
static int xinitialized=0;
if(!xinitialized){xinputwrap_create_master();xinitialized=1;}
xinputwrap_reattach((switch_)?"Keyb pointer":"Virtual core pointer");
return 0;
}

